=begin
###
Copyright 2012 TIG (c)
Permission to use, copy, modify, and distribute this software for 
any purpose and without fee is hereby granted, provided something the 
above copyright notice appear in all copies.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
###
Ensures that the selection-set is emptied when you save, to ensure that 
the 'smoothing glitch' on reopening is avoided.
###
=end
###
require 'sketchup.rb'
###
module TIG
  ### Ensures selection is empty as you save SKP.
  @@smoothingSelectionGlitchArray=[]
  class TIG::SmoothingSelectionGlitchModelObserver < Sketchup::ModelObserver
    def onPreSaveModel(model)
	  ss=model.selection
	  p @@smoothingSelectionGlitchArray=ss.to_a
	  ss.clear
    end
    def onPostSaveModel(model)
	  ss=model.selection
	  ss.add(@@smoothingSelectionGlitchArray) if @@smoothingSelectionGlitchArray[0]
    end
  end#class
  ### Attach the model-observer.
  Sketchup.active_model.add_observer(TIG::SmoothingSelectionGlitchModelObserver.new())
  ###
  ### Ensure the model-observer is added to any 'new' SKPs
  class TIG::SmoothingSelectionGlitchAppObserver < Sketchup::AppObserver
    def onNewModel(model)
	  @@smoothingSelectionGlitchArray=[]
      model.add_observer(TIG::SmoothingSelectionGlitchModelObserver.new())
    end
    def onOpenModel(model)
	  @@smoothingSelectionGlitchArray=[]
      model.add_observer(TIG::SmoothingSelectionGlitchModelObserver.new())
    end
  end#class
  ### Attach the app-observer initially.
  Sketchup.add_observer(TIG::SmoothingSelectionGlitchAppObserver.new())
end
###